		
	-----------------------------
	-- INIT
	-----------------------------

	--get the addon namespace
	local addon, ns = ...
	local gcfg = ns.cfg
	--get some values from the namespace
	local cfg = gcfg.units.boss
	
	for i = 1, 5 do
		local f = _G["Boss"..i.."TargetFrame"]
		f:ClearAllPoints()
		f:SetParent(UIParent)
		f:SetScale(cfg.scale)
		if i == 1 then
			f:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
		else
			local previous = _G["Boss"..(i-1).."TargetFrame"]
			f:SetPoint("BOTTOMRIGHT", previous, "TOPRIGHT", 0, cfg.spacing)
		end
		f.SetPoint = function() end  -- makes the frames unable to moved again. Otherwise they would return to default position when encountering a boss
	end