	
	-----------------------------
	-- INIT
	-----------------------------

	--get the addon namespace
	local addon, ns = ...
	local gcfg = ns.cfg
	--get some values from the namespace
	local cfg = gcfg.units.portraits
	
	-----------------------------
	-- ClassIcons
	-----------------------------

	if not cfg.classIcon.enable then return end
		hooksecurefunc("UnitFramePortrait_Update",function(self)
			if self.portrait then
				if UnitIsPlayer(self.unit) then                         
					local t = CLASS_ICON_TCOORDS[select(2, UnitClass(self.unit))]
					if t then
						self.portrait:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
						self.portrait:SetTexCoord(unpack(t))
					end
				else
					self.portrait:SetTexCoord(0,1,0,1)
				end
			end
		end)
		
	-----------------------------
	-- Druid forms icons
	-----------------------------
		
	if not cfg.classIcon.druidForms then return end	
	UFP = "UnitFramePortrait_Update"
	UICC = "Interface\\TargetingFrame\\UI-Classes-Circles"
	CIT = CLASS_ICON_TCOORDS
	 
	hooksecurefunc("UnitFramePortrait_Update",function(self)
	 
		if self.portrait then
	 
			if select(2,UnitClass(self.unit)) == "DRUID" then
	 
			  local i, flag=1, false
	 
			  while UnitBuff(self.unit, i) do
	 
				 local id = select(11,UnitBuff(self.unit, i))
	 
				 --768 (Cat Form)  783(Travel Form) 1066 (Aquatic Form) 5487 (Bear Form) 24858 (Moonkin Form) 33891 (Tree of Life) 33943 (Flight Form) 40120 (Swift Flight Form) 171745 (Claws of Shirvallah)
				 --Claws of Shirvallah needs a 64x64 icon
	 
				 if id == 768 or id == 783 or id == 1066 or id == 5487 or id == 24858 or id == 33891 or id == 33943 or id == 40120 then
	 
				   SetPortraitToTexture(self.portrait, GetSpellTexture(id));
	 
				   self.portrait:SetTexCoord(0, 1, 0, 1)
	 
				   flag = true			 
	 
				 end
	 
				 i = i + 1
	 
			   end
	 
			  if not flag then
	 
				 self.portrait:SetTexture(UICC)
	 
				 self.portrait:SetTexCoord(unpack(CIT.DRUID))
	 
			 end
	 
		   else
	 
			 local t = CIT[select(2,UnitClass(self.unit))]
	 
				 if t then self.portrait:SetTexture(UICC)
	 
				 self.portrait:SetTexCoord(unpack(t))
	 
			 end
	 
		   end
	 
	   end
	 
	end)